VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PrintJob"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum FileOpCodes
  focUnknown = -1
  focSuccess = 0
  focLoadError = 10
  focLoadFileNotExist
  focLoadBadFileName
  focLoadNoAccess
  focLoadWrongFile
  focSaveError = 20
  focSaveBadFileName
  focSaveWriteError
  focSaveNoAccess
  focGeneralError = 99
End Enum

Public Enum ObjectTypes
  pjoPoint = 1
  pjoLine = 2
  pjoCircle = 3
  pjoBox = 4
  pjoImage = 5
  pjoTextBox = 8
  pjoText = 9
End Enum

Private colObjects As Collection

Private vOriginX As Single, vOriginY As Single
Private vRevertXAxis As Boolean, vRevertYAxis As Boolean

Private vFont As StdFont
Private vForeColor As OLE_COLOR
Private vBackColor As OLE_COLOR
Private vLineWidth As Single
Private vFormatText As Boolean
Private vVarNames() As String, vVarValues() As String
Private vTag As String

Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32" () As Long

Private Type TextRectType
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type
Private Type TextDrawParams
  StructSize As Long
  TabLength As Long
  LeftMargin As Long
  RightMargin As Long
  LengthDrawn As Long
End Type

Private Enum TextAlignEnum
  taTop = 0
  taBottom = 8
  taLeft = 0
  taCenter = 6
  taRight = 2
  taBaseline = 24
End Enum

Private Enum DrawTextParamsEnum
  dtTop = &H0&
  dtLeft = &H0&
  dtCenter = &H1&
  dtRight = &H2&
  dtMiddle = &H4&
  dtBottom = &H8&
  dtWordBreak = &H10&
  dtSingleLine = &H20&
  dtExpandTabs = &H40&
  dtTabStop = &H80&
  dtNoClip = &H100&
  dtExternalLeading = &H200&
  dtCalcRect = &H400&
  dtNoPrefix = &H800&
  dtInternal = &H1000&
  dtEditControl = &H2000&
  dtModifyString = &H10000
  dtRTLReading = &H20000
  dtWordEllipsis = &H40000
  dtPathEllipsis = &H4000&
  dtEndEllipsis = &H8000&
End Enum

Private Declare Function BeginPath Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function EndPath Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function GetTextAlign Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function SetTextAlign Lib "gdi32" (ByVal hDC As Long, ByVal AlignFlag As TextAlignEnum) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal Text As String, ByVal TextLen As Long) As Long
Private Declare Function ExtTextOut Lib "gdi32" Alias "ExtTextOutA" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal TextOptions As Long, TextRect As Any, ByVal Text As String, ByVal TextLen As Long, CharDelta As Long) As Long
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal Text As String, ByVal TextLen As Long, TextRect As TextRectType, ByVal TextFormat As DrawTextParamsEnum) As Long
Private Declare Function DrawTextEx Lib "user32" Alias "DrawTextExA" (ByVal hDC As Long, ByVal Text As String, ByVal TextLen As Long, TextRect As TextRectType, ByVal TextFormat As DrawTextParamsEnum, TextParams As Any) As Long

Private Enum BitmapColorUsage
  DIB_RGB_COLORS = 0
  DIB_PAL_COLORS = 1
End Enum
Private Type RGBQuad
  rgbBlue As Byte
  rgbGreen As Byte
  rgbRed As Byte
  rgbReserved As Byte
End Type
Private Type BitmapInfoHeader
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed As Long
  biClrImportant As Long
End Type
Private Type BitmapInfo
  bmiHeader As BitmapInfoHeader
  bmiColors As RGBQuad
End Type
Private Declare Function GetDIBits Lib "gdi32" (ByVal hDC As Long, ByVal hBitmap As Long, ByVal StartScan As Long, ByVal NumScans As Long, ByVal pBits As Long, pBitmapInfo As BitmapInfo, ByVal ColorUsage As BitmapColorUsage) As Long

Public Property Get OriginX() As Single
OriginX = vOriginX
End Property

Public Property Let OriginX(ByVal NewValue As Single)
vOriginX = NewValue
End Property

Public Property Get OriginY() As Single
OriginY = vOriginY
End Property

Public Property Let OriginY(ByVal NewValue As Single)
vOriginY = NewValue
End Property

Public Property Get RevertXAxis() As Boolean
RevertXAxis = vRevertXAxis
End Property

Public Property Let RevertXAxis(ByVal NewValue As Boolean)
vRevertXAxis = NewValue
End Property

Public Property Get RevertYAxis() As Boolean
RevertYAxis = vRevertYAxis
End Property

Public Property Let RevertYAxis(ByVal NewValue As Boolean)
vRevertXAxis = NewValue
End Property

Private Sub GetRealPos(Disp As Printer, ByRef X As Single, ByRef Y As Single, ByVal SrcX As Single, ByVal SrcY As Single)
X = vOriginX + SrcX
Y = vOriginY + SrcY
End Sub

Private Function GetDrawWidth(Disp As Printer, ByVal Width As Single, Optional ByVal X1 As Single, Optional Y1 As Single, Optional X2 As Single, Optional Y2 As Single) As Long
Dim W As Single, H As Single, DW As Single, DH As Single, L As Single
W = Abs(X2 - X1): H = Abs(Y2 - Y1)
DW = Disp.ScaleX(Width, vbMillimeters, vbPixels)
DH = Disp.ScaleY(Width, vbMillimeters, vbPixels)
If W = 0 And H = 0 Then
  L = (DW + DH) / 2
ElseIf W = 0 And H > 0 Then
  L = DH
ElseIf H = 0 And W > 0 Then
  L = DW
Else
  L = (DW * W + DH * H) / (W + H)
End If
If Round(L) = 0 Then
  GetDrawWidth = 1
Else
  GetDrawWidth = Round(L)
End If
End Function

Private Sub WrapText(Disp As Printer, ByVal Text As String, WrapText() As String, ByVal AreaWidth As Single, Optional ByVal WrapZone As Single)
Dim N As Long, I0 As Long, I As Long, S As String, L As Long, W As Single
Text = Text & vbNewLine
ReDim WrapText(0)
I0 = 1
N = 0
Do
  I = InStr(I0, Text, vbNewLine)
  If I = 0 Then Exit Do
  S = Mid$(Text, I0, I - I0)
  I0 = I + Len(vbNewLine)
  W = Disp.TextWidth(S)
  If W <= AreaWidth Then
    N = N + 1
    ReDim Preserve WrapText(0 To N)
    WrapText(N) = S
  Else
    I = 1
    Do
      L = 0
      Do Until I + L > Len(S)
        L = L + 1
        If Disp.TextWidth(Mid$(S, I, L + 1)) > AreaWidth Then
          If InStrRev(S, vbSpace, I + L) > 0 Then L = InStrRev(S, vbSpace, I + L) - I + 1
          Exit Do
        End If
      Loop
      If L = 0 Then Exit Do
      N = N + 1
      ReDim Preserve WrapText(0 To N)
      WrapText(N) = Mid$(S, I, L)
      I = I + L
    Loop
  End If
Loop
End Sub

Private Function RetrieveText(ByVal Text As String) As String
Dim I As Long
For I = 1 To UBound(vVarNames)
  Text = Replace(Text, "%" & vVarNames(I) & "%", vVarValues(I))
Next I
RetrieveText = Text
End Function

Private Function GetColorFromString(ByVal Value As String) As Long
Dim R As Long, G As Long, B As Long, P As Long, P0 As Long, S As String
If UCase$(Left$(Value, 2)) = "&H" Then
  GetColorFromString = Val(Value)
  Exit Function
End If
If Right$(Value, 1) <> vbSpace Then Value = Value & vbSpace
P0 = 1
Do
  P = InStr(P0, Value, vbSpace)
  If P = 0 Then Exit Do
  S = UCase$(Trim$(Mid$(Value, P0, P - P0)))
  P0 = P + Len(vbSpace)
  Select Case Left$(S, 1)
    Case "R"
      R = Val(Mid$(S, 2))
    Case "G"
      G = Val(Mid$(S, 2))
    Case "B"
      B = Val(Mid$(S, 2))
  End Select
Loop
GetColorFromString = RGB(R, G, B)
End Function

Private Sub GetPointFromString(ByVal Value As String, ByRef X As Single, ByRef Y As Single)
Dim P As Long
If Left$(Value, 1) = "(" And Right$(Value, 1) = ")" Then Value = Mid$(Value, 2, Len(Value) - 2)
P = InStr(Value, ";")
X = Val(Left$(Value, P - 1))
Y = Val(Mid$(Value, P + 1))
End Sub

Private Sub GetBoxFromString(ByVal Value As String, ByRef X1 As Single, ByRef Y1 As Single, ByRef X2 As Single, ByRef Y2 As Single)
Dim P As Long
P = InStr(Value, "-")
If P > 0 Then
  Call GetPointFromString(Left$(Value, P - 1), X1, Y1)
  Call GetPointFromString(Mid$(Value, P + 1), X2, Y2)
End If
End Sub

Public Function Load(ByVal FileName As String) As FileOpCodes

End Function

Private Function FontToString(pFont As StdFont) As String
FontToString = pFont.Name & "," & pFont.Charset & ";" & Str$(pFont.Size) & ";" & IIf(pFont.Bold, "B", "b") & IIf(pFont.Italic, "I", "i") & IIf(pFont.Underline, "U", "u") & IIf(pFont.Strikethrough, "S", "s")
End Function

Private Function PictureToString(pImage As StdPicture) As String
If pImage Is Nothing Then Exit Function
Dim A() As Byte, BI As BitmapInfo, I As Long
BI.bmiHeader.biSize = Len(BI.bmiHeader)
I = GetDIBits(GetDC(GetDesktopWindow()), pImage.Handle, 0&, 0&, ByVal 0&, BI, DIB_RGB_COLORS)
BI.bmiHeader.biBitCount = 24
If BI.bmiHeader.biSizeImage = 0 Then
  I = BI.bmiHeader.biHeight * BI.bmiHeader.biWidth * BI.bmiHeader.biBitCount / 8
Else
  I = BI.bmiHeader.biSizeImage
End If
I = (CLng(I + 3) \ 4) * 4
ReDim A(0 To I - 1)
I = GetDIBits(GetDC(GetDesktopWindow()), pImage.Handle, 0&, BI.bmiHeader.biHeight, A(0), BI, DIB_RGB_COLORS)
PictureToString = StrConv(A(), vbUnicode)
PictureToString = Var2Hex(CLng(Len(PictureToString))) & PictureToString
End Function

Public Function Save(ByVal FileName As String) As FileOpCodes
Dim FN As Integer, buff As String, I As Long
buff = "BRPT" & vbNullChar & "DO NOT EDIT THIS FILE" & Chr$(26)
buff = buff & "X0=" & Var2Hex(vOriginX) & vbTab
buff = buff & "Y0=" & Var2Hex(vOriginY) & vbTab
buff = buff & "RX=" & Var2Hex(vRevertXAxis) & vbTab
buff = buff & "RY=" & Var2Hex(vRevertYAxis) & vbTab
buff = buff & "FNT=" & FontToString(vFont) & vbTab
buff = buff & "CLR=" & Var2Hex(vForeColor) & ":" & Var2Hex(vBackColor) & vbTab
buff = buff & "LW=" & Var2Hex(vLineWidth) & vbTab
buff = buff & "FT=" & Var2Hex(vFormatText) & vbTab
buff = buff & "TAG=" & Var2Hex(vTag) & vbNullChar
buff = buff & "VARLIST" & vbTab
For I = 1 To UBound(vVarNames)
  buff = buff & Var2Hex(vVarNames(I)) & "," & Var2Hex(vVarValues(I)) & ";"
Next I
buff = buff & vbNullChar & "OBJECTS" & vbNullChar
For I = 1 To colObjects.Count
  buff = buff & Var2Hex(I) & "#" & Var2Hex(colObjects(I).Name) & "-"
  If TypeOf colObjects(I) Is PrnPoint Then
    buff = buff & "POINT" & vbTab
    buff = buff & "POS=" & Var2Hex(colObjects(I).X) & ";" & Var2Hex(colObjects(I).Y) & vbTab
    buff = buff & "D=" & Var2Hex(colObjects(I).Diameter) & vbTab
    buff = buff & "CLR=" & Var2Hex(colObjects(I).ForeColor) & vbTab
  ElseIf TypeOf colObjects(I) Is PrnLine Then
    buff = buff & "LINE" & vbTab
    buff = buff & "POS=" & Var2Hex(colObjects(I).X1) & ";" & Var2Hex(colObjects(I).Y1) & "-" & Var2Hex(colObjects(I).X2) & ";" & Var2Hex(colObjects(I).Y2) & vbTab & vbTab
    buff = buff & "LW=" & Var2Hex(colObjects(I).LineWidth) & vbTab
    buff = buff & "CLR=" & Var2Hex(colObjects(I).ForeColor) & vbTab
  ElseIf TypeOf colObjects(I) Is PrnCircle Then
    buff = buff & "CIRCLE" & vbTab
    buff = buff & "POS=" & Var2Hex(colObjects(I).X0) & ";" & Var2Hex(colObjects(I).Y0) & vbTab
    buff = buff & "R=" & Var2Hex(colObjects(I).Radius) & vbTab
    buff = buff & "A=" & Var2Hex(colObjects(I).Aspect) & vbTab
    buff = buff & "LW=" & Var2Hex(colObjects(I).LineWidth) & vbTab
    buff = buff & "CLR=" & Var2Hex(colObjects(I).ForeColor) & ":" & Var2Hex(colObjects(I).BackColor) & vbTab
    buff = buff & "DRW=" & Var2Hex(colObjects(I).Outline) & ";" & Var2Hex(colObjects(I).Fill) & vbTab
  ElseIf TypeOf colObjects(I) Is PrnBox Then
    buff = buff & "BOX" & vbTab
    buff = buff & "POS=" & Var2Hex(colObjects(I).X1) & ";" & Var2Hex(colObjects(I).Y1) & "-" & Var2Hex(colObjects(I).X2) & ";" & Var2Hex(colObjects(I).Y2) & vbTab & vbTab
    buff = buff & "R=" & Var2Hex(colObjects(I).Round) & vbTab
    buff = buff & "LW=" & Var2Hex(colObjects(I).LineWidth) & vbTab
    buff = buff & "CLR=" & Var2Hex(colObjects(I).ForeColor) & ":" & Var2Hex(colObjects(I).BackColor) & vbTab
    buff = buff & "DRW=" & Var2Hex(colObjects(I).Outline) & ";" & Var2Hex(colObjects(I).Fill) & vbTab
  ElseIf TypeOf colObjects(I) Is PrnImage Then
    buff = buff & "IMAGE" & vbTab
    buff = buff & "POS=" & Var2Hex(colObjects(I).X1) & ";" & Var2Hex(colObjects(I).Y1) & "-" & Var2Hex(colObjects(I).X2) & ";" & Var2Hex(colObjects(I).Y2) & vbTab & vbTab
    buff = buff & "IMG=" & PictureToString(colObjects(I).Image) & vbTab
    buff = buff & "LW=" & Var2Hex(colObjects(I).LineWidth) & vbTab
    buff = buff & "CLR=" & Var2Hex(colObjects(I).ForeColor) & ":" & Var2Hex(colObjects(I).BackColor) & vbTab
    buff = buff & "DRW=" & Var2Hex(colObjects(I).Outline) & ";" & Var2Hex(colObjects(I).Fill) & vbTab
  ElseIf TypeOf colObjects(I) Is PrnTextBox Then
    buff = buff & "TEXTBOX" & vbTab
    buff = buff & "POS=" & Var2Hex(colObjects(I).X1) & ";" & Var2Hex(colObjects(I).Y1) & "-" & Var2Hex(colObjects(I).X2) & ";" & Var2Hex(colObjects(I).Y2) & vbTab & vbTab
    buff = buff & "LW=" & Var2Hex(colObjects(I).LineWidth) & vbTab
    buff = buff & "CLR=" & Var2Hex(colObjects(I).ForeColor) & ":" & Var2Hex(colObjects(I).BackColor) & vbTab
    buff = buff & "DRW=" & Var2Hex(colObjects(I).Outline) & ";" & Var2Hex(colObjects(I).Fill) & vbTab
    buff = buff & "FNT=" & FontToString(colObjects(I).Font) & vbTab
    buff = buff & "ALG=" & Var2Hex(colObjects(I).AlignX) & ";" & Var2Hex(colObjects(I).AlignY) & vbTab
    buff = buff & "FRM=" & Var2Hex(colObjects(I).FormatText) & vbTab
    buff = buff & "WRP=" & Var2Hex(colObjects(I).WrapMode) & vbTab
    buff = buff & "TXT=" & Var2Hex(colObjects(I).Text) & vbTab
  ElseIf TypeOf colObjects(I) Is PrnText Then
    buff = buff & "TEXT" & vbTab
    buff = buff & "POS=" & Var2Hex(colObjects(I).X) & ";" & Var2Hex(colObjects(I).Y) & vbTab
    buff = buff & "LW=" & Var2Hex(colObjects(I).OutlineWidth) & vbTab
    buff = buff & "CLR=" & Var2Hex(colObjects(I).OutlineColor) & ":" & Var2Hex(colObjects(I).FillColor) & vbTab
    buff = buff & "DRW=" & Var2Hex(colObjects(I).Outline) & ";" & Var2Hex(colObjects(I).Fill) & vbTab
    buff = buff & "FNT=" & FontToString(colObjects(I).Font) & vbTab
    buff = buff & "ALG=" & Var2Hex(colObjects(I).AlignX) & ";" & Var2Hex(colObjects(I).AlignY) & vbTab
    buff = buff & "MRR=" & Var2Hex(colObjects(I).MirrorX) & ";" & Var2Hex(colObjects(I).MirrorY) & vbTab
    buff = buff & "A=" & Var2Hex(colObjects(I).Angle) & vbTab
    buff = buff & "TXT=" & Var2Hex(colObjects(I).Text) & vbTab
  End If
  buff = buff & vbNullChar
Next I
buff = buff & vbNullChar & "FILE=" & FileName & Chr$(26)
Save = focUnknown
FN = FreeFile
On Error Resume Next
Open FileName For Output As #FN
Select Case Err.Number
  Case 0
    Save = focSaveError
  Case 52, 54, 75, 76
    Save = focSaveBadFileName
  Case 57, 61, 68, 71
    Save = focSaveWriteError
  Case 70
    Save = focSaveNoAccess
  Case Else
    Save = focSaveError
End Select
If Err.Number > 0 Then
  Err.Clear
  Exit Function
End If
Print #FN, buff;
Select Case Err.Number
  Case 0
    Save = focSaveError
  Case 57, 61, 68, 71
    Save = focSaveWriteError
  Case 70
    Save = focSaveNoAccess
  Case Else
    Save = focSaveError
End Select
If Err.Number > 0 Then
  Err.Clear
  Exit Function
End If
Close #FN
If Err.Number > 0 Then
  Save = focGeneralError
  Err.Clear
  Exit Function
End If
On Error GoTo 0
Save = focSuccess
End Function

Public Sub LoadTextBuffer(ByVal Buffer As String, Optional ByVal Y0 As Single)
Dim P As Long, P0 As Long, L As String, B As String, N As String
Dim FC As Collection, I As Long, S As String, fInsideMode As Boolean
Const BeginWord As String = "BEGIN", EndWord As String = "END"
Const FontWord As String = "FONT", ShapeWord As String = "SHAPE"
If Right$(Buffer, Len(vbNewLine)) <> vbNewLine Then Buffer = Buffer & vbNewLine
fInsideMode = False
Set FC = New Collection
S = vbNullString
L = vbNullString
B = vbNullString
N = vbNullString
P0 = 1
Do
  P = InStr(P0, Buffer, vbNewLine)
  If P = 0 Then Exit Do
  L = Trim$(Mid$(Buffer, P0, P - P0))
  If Left$(L, 1) = ";" Then L = vbNullString
  P0 = P + Len(vbNewLine)
  S = UCase$(L)
  If fInsideMode Then
    If Left$(S, Len(EndWord) + 1) = EndWord & vbSpace Then
      If Left$(S, Len(EndWord) + Len(FontWord) + 1) = EndWord & vbSpace & FontWord Then
        If UCase$(Left$(N, Len(FontWord))) = FontWord Then
          fInsideMode = False
          S = vbNullString
          N = Mid$(N, Len(FontWord) + 2)
          FC.Add Key:=N, Item:=LoadBufferFont(B)
        End If
      ElseIf Left$(S, Len(EndWord) + Len(ShapeWord) + 1) = EndWord & vbSpace & ShapeWord Then
        If UCase$(Left$(N, Len(ShapeWord))) = ShapeWord Then
          fInsideMode = False
          S = Mid$(N, Len(ShapeWord) + 2)
          I = InStr(S, vbSpace)
          If I = 0 Then
            N = vbNullString
          Else
            N = Mid$(S, I + Len(vbSpace))
            S = Left$(S, I - 1)
          End If
          LoadBufferShape B, FC, S, N, Y0
        End If
      End If
    End If
    If fInsideMode Then B = B & L & vbNewLine
  Else
    If Left$(S, Len(BeginWord) + 1) = BeginWord & vbSpace Then
      If Left$(S, Len(BeginWord) + Len(FontWord) + 2) = BeginWord & vbSpace & FontWord & vbSpace Then
        fInsideMode = True
        B = vbNullString
        N = Mid$(L, Len(BeginWord) + 2)
      ElseIf Left$(S, Len(BeginWord) + Len(ShapeWord) + 2) = BeginWord & vbSpace & ShapeWord & vbSpace Then
        fInsideMode = True
        B = vbNullString
        N = Mid$(L, Len(BeginWord) + 2)
      End If
    End If
  End If
Loop
While FC.Count > 0
  FC.Remove 1
Wend
Set FC = Nothing
End Sub

Private Function LoadBufferFont(ByVal Buffer As String) As StdFont
Dim P As Long, P0 As Long, L As String, N As String, V As String
Set LoadBufferFont = New StdFont
P0 = 1
Do
  P = InStr(P0, Buffer, vbNewLine)
  If P = 0 Then Exit Do
  L = Trim$(Mid$(Buffer, P0, P - P0))
  If Left$(L, 1) = ";" Then L = vbNullString
  P0 = P + Len(vbNewLine)
  P = InStr(L, "=")
  If P > 0 Then
    N = UCase$(Trim$(Left$(L, P - 1)))
    V = Trim$(Mid$(L, P + 1))
    Select Case N
      Case "NAME"
        If Left$(V, 1) = vbQuote And Right$(V, 1) = vbQuote Then V = Mid$(V, 2, Len(V) - 2)
        LoadBufferFont.Name = V
      Case "CHARSET"
        LoadBufferFont.Charset = Val(V)
      Case "SIZE"
        LoadBufferFont.Size = Val(V)
      Case "BOLD"
        LoadBufferFont.Bold = CBool(V)
      Case "ITALIC"
        LoadBufferFont.Italic = CBool(V)
      Case "UNDERLINE"
        LoadBufferFont.Underline = CBool(V)
    End Select
  End If
Loop
End Function

Private Sub LoadBufferShape(ByVal Buffer As String, ByRef FontCollection As Collection, ByVal ShapeType As String, Optional ByVal ShapeName As String, Optional ByVal Y0 As Single)
Dim P As Long, P0 As Long, L As String, N As String, V As String
Dim lX1 As Single, lY1 As Single, lX2 As Single, lY2 As Single, lSize As Single
Dim lForeColor As Long, lBackColor As Long, lOutline As Boolean, lFilled As Boolean
Dim lPicture As StdPicture, lFont As StdFont, S As String
Dim lText As String, lFormat As Boolean, lAngle As Single, lAlignX As Integer, lAlignY As Integer, lMirrorX As Boolean, lMirrorY As Boolean, lWrap As Boolean
If Len(ShapeName) > 0 Then
  If CheckExist(ShapeName, Decode(UCase$(ShapeType), "POINT", ObjectTypes.pjoPoint, "LINE", ObjectTypes.pjoLine, "BOX", ObjectTypes.pjoBox, "CIRCLE", ObjectTypes.pjoCircle, "IMAGE", ObjectTypes.pjoImage, "TEXT", ObjectTypes.pjoText, "TEXTBOX", ObjectTypes.pjoTextBox)) Then Exit Sub
End If
P0 = 1
Do
  P = InStr(P0, Buffer, vbNewLine)
  If P = 0 Then Exit Do
  L = Trim$(Mid$(Buffer, P0, P - P0))
  If Left$(L, 1) = ";" Then L = vbNullString
  P0 = P + Len(vbNewLine)
  P = InStr(L, "=")
  If P > 0 Then
    N = UCase$(Trim$(Left$(L, P - 1)))
    V = Trim$(Mid$(L, P + 1))
    Select Case N
      Case "X", "X1"
        lX1 = Val(V)
      Case "Y", "Y1"
        lY1 = Val(V)
      Case "X2", "RADIUS"
        lX2 = Val(V)
      Case "Y2"
        lY2 = Val(V)
      Case "P", "P1"
        Call GetPointFromString(V, lX1, lY1)
      Case "P2"
        Call GetPointFromString(V, lX2, lY2)
      Case "WIDTH"
        lX2 = lX1 + Val(V)
      Case "HEIGHT"
        lY2 = lY1 + Val(V)
      Case "BOX"
        Call GetBoxFromString(V, lX1, lY1, lX2, lY2)
      Case "RECT"
        Call GetBoxFromString(V, lX1, lY1, lX2, lY2)
        lX2 = lX1 + lX2
        lY2 = lY1 + lY2
      Case "LINEWIDTH", "OUTLINEWIDTH", "DIAMETER"
        lSize = Val(V)
      Case "COLOR", "FORECOLOR", "OUTLINECOLOR"
        lForeColor = GetColorFromString(V)
      Case "BACKCOLOR", "FILLCOLOR"
        lBackColor = GetColorFromString(V)
      Case "OUTLINE"
        lOutline = CBool(V)
      Case "FILL"
        lFilled = CBool(V)
      Case "ALIGNX"
        lAlignX = Decode(UCase$(V), "LEFT", 1, "CENTER", 2, "RIGHT", 3, 0)
      Case "ALIGNY"
        lAlignY = Decode(UCase$(V), "TOP", 1, "MIDDLE", 2, "CENTER", 2, "BOTTOM", 3, 0)
      Case "MIRRORX"
        lMirrorX = CBool(V)
      Case "MIRRORY"
        lMirrorY = CBool(V)
      Case "WRAP", "WRAPMODE"
        lWrap = CBool(V)
      Case "ANGLE"
        lAngle = Val(V)
      Case "TEXT"
        If Left$(V, 1) = vbQuote And Right$(V, 1) = vbQuote Then V = Mid$(V, 2, Len(V) - 2)
        lText = Replace(V, "\", vbNewLine)
      Case "FORMAT"
        lFormat = CBool(V)
      Case "FONT"
        Set lFont = FontCollection.Item(V)
      Case "IMAGE", "PICTURE"
        On Error Resume Next
        If Left$(V, 1) = "<" And Right$(V, 1) = ">" Then
          Set lPicture = LoadResPicture(Mid$(V, 2, Len(V) - 2), vbResBitmap)
        Else
          If InStr(V, ":") = 0 And Left$(V, 2) <> "\\" Then V = AppPath & V
          Set lPicture = LoadPicture(V)
        End If
        Err.Clear
        On Error GoTo 0
    End Select
  End If
Loop
lY1 = Y0 + lY1
lY2 = Y0 + lY2
Select Case UCase$(ShapeType)
  Case "POINT"
    With AddPoint(ShapeName, lX1, lY1, lForeColor)
      .Diameter = lSize
    End With
  Case "LINE"
    With AddLine(ShapeName, lX1, lY1, lX2, lY2, lSize, lForeColor)
    End With
  Case "BOX"
    With AddBox(ShapeName, lX1, lY1, lX2, lY2, lSize, lForeColor, lBackColor)
      .Outline = lOutline
      .Fill = lFilled
    End With
  Case "CIRCLE"
    With AddCircle(ShapeName, lX1, lY1, lX2, lSize, lForeColor)
      .Outline = lOutline
      .Fill = lFilled
    End With
  Case "IMAGE"
    With AddImage(ShapeName, lX1, lY1, lX2, lY2, lPicture)
      .ForeColor = lForeColor
      .Outline = lOutline
      .BackColor = lBackColor
      .Fill = lFilled
    End With
  Case "TEXT"
    With AddText(ShapeName, lX1, lY1, lText, lForeColor)
      .OutlineWidth = lSize
      .OutlineColor = lForeColor
      .Outline = lOutline
      .FillColor = lBackColor
      .Fill = lFilled
      .MirrorX = lMirrorX
      .MirrorY = lMirrorY
      .AlignX = lAlignX
      .AlignY = lAlignY
      Set .Font = lFont
      .Angle = lAngle
      .Text = lText
    End With
  Case "TEXTBOX"
    With AddTextBox(ShapeName, lX1, lY1, lX2, lY2, lText, lForeColor, lFormat)
      .LineWidth = lSize
      .ForeColor = lForeColor
      .Outline = lOutline
      .BackColor = lBackColor
      .Fill = lFilled
      .AlignX = lAlignX
      .AlignY = lAlignY
      Set .Font = lFont
      .Text = lText
      .WrapMode = lWrap
    End With
End Select
End Sub

Public Sub PrintCurrentJob(Disp As Printer)
Dim C As Long, I As Long, obj As Object, X0 As Single, Y0 As Single, X1 As Single, Y1 As Single, X2 As Single, Y2 As Single, W As Single, H As Single, T As String, WT() As String
If colObjects.Count = 0 Then Exit Sub
X0 = (Disp.ScaleX(Disp.Width, vbTwips, vbMillimeters) - Disp.ScaleX(Disp.ScaleWidth, Disp.ScaleMode, vbMillimeters)) / 2
Y0 = (Disp.ScaleY(Disp.Height, vbTwips, vbMillimeters) - Disp.ScaleY(Disp.ScaleHeight, Disp.ScaleMode, vbMillimeters)) / 2
Disp.ScaleMode = vbMillimeters
For C = 1 To colObjects.Count
  Set Disp.Font = vFont
  Disp.ForeColor = vForeColor
  Disp.DrawWidth = GetDrawWidth(Disp, vLineWidth)
  Disp.DrawStyle = vbSolid
  Disp.FillStyle = vbFSTransparent
  Disp.FillColor = vBackColor
  Set obj = colObjects.Item(C)
  If TypeOf obj Is PrnPoint Then
    GetRealPos Disp, X1, Y1, obj.X, obj.Y
    Disp.ForeColor = obj.ForeColor
    Disp.FillStyle = vbFSSolid
    Disp.FillColor = obj.ForeColor
    Disp.DrawStyle = vbInvisible
    Disp.Circle (X1 - X0, Y1 - Y0), obj.Diameter / 2
  ElseIf TypeOf obj Is PrnLine Then
    GetRealPos Disp, X1, Y1, obj.X1, obj.Y1
    GetRealPos Disp, X2, Y2, obj.X2, obj.Y2
    Disp.DrawWidth = GetDrawWidth(Disp, obj.LineWidth, X1, Y1, X2, Y2)
    Disp.Line (X1 - X0, Y1 - Y0)-(X2 - X0, Y2 - Y0), obj.ForeColor
  ElseIf TypeOf obj Is PrnCircle Then
    GetRealPos Disp, X1, Y1, obj.X0, obj.Y0
    If obj.Fill Then
      Disp.DrawWidth = 1
      Disp.DrawStyle = vbInvisible
      Disp.FillStyle = vbFSSolid
      Disp.FillColor = obj.BackColor
      Disp.Circle (X1 - X0, Y1 - Y0), obj.Radius
    End If
    Disp.DrawWidth = GetDrawWidth(Disp, obj.LineWidth)
    Disp.DrawStyle = vbSolid
    If obj.Outline Then Disp.Circle (X1 - X0, Y1 - Y0), obj.Radius, obj.ForeColor
  ElseIf TypeOf obj Is PrnBox Then
    GetRealPos Disp, X1, Y1, obj.X1, obj.Y1
    GetRealPos Disp, X2, Y2, obj.X2, obj.Y2
    Disp.DrawWidth = 1
    If obj.Fill Then Disp.Line (X1 - X0, Y1 - Y0)-(X2 - X0, Y2 - Y0), obj.BackColor, BF
    Disp.DrawWidth = GetDrawWidth(Disp, obj.LineWidth)
    If obj.Outline Then Disp.Line (X1 - X0, Y1 - Y0)-(X2 - X0, Y2 - Y0), obj.ForeColor, B
  ElseIf TypeOf obj Is PrnImage Then
    GetRealPos Disp, X1, Y1, obj.X1, obj.Y1
    GetRealPos Disp, X2, Y2, obj.X2, obj.Y2
    Disp.DrawWidth = 1
    If obj.Fill Then Disp.Line (X1 - X0, Y1 - Y0)-(X2 - X0, Y2 - Y0), obj.BackColor, BF
    Disp.DrawWidth = GetDrawWidth(Disp, obj.LineWidth)
    If obj.Outline Then Disp.Line (X1 - X0, Y1 - Y0)-(X2 - X0, Y2 - Y0), obj.ForeColor, B
    If Not obj.Image Is Nothing Then Disp.PaintPicture obj.Image, X1 - X0, Y1 - Y0, X2 - X1, Y2 - Y1
  ElseIf TypeOf obj Is PrnTextBox Then
    GetRealPos Disp, X1, Y1, obj.X1, obj.Y1
    GetRealPos Disp, X2, Y2, obj.X2, obj.Y2
    Disp.DrawWidth = 1
    If obj.Fill Then Disp.Line (X1 - X0, Y1 - Y0)-(X2 - X0, Y2 - Y0), obj.BackColor, BF
    Disp.DrawWidth = GetDrawWidth(Disp, obj.LineWidth)
    If obj.Outline Then Disp.Line (X1 - X0, Y1 - Y0)-(X2 - X0, Y2 - Y0), obj.ForeColor, B
    Disp.ForeColor = obj.ForeColor
    Set Disp.Font = New StdFont
    Disp.Font.Name = obj.Font.Name
    Disp.Font.Charset = obj.Font.Charset
    Disp.Font.Size = obj.Font.Size
    Disp.Font.Bold = obj.Font.Bold
    Disp.Font.Italic = obj.Font.Italic
    Disp.Font.Underline = obj.Font.Underline
    Call WrapText(Disp, obj.Text, WT(), X2 - X1)
    H = Disp.TextHeight(vbNullString) * UBound(WT)
    Disp.CurrentY = Y1 - Y0
    Select Case obj.AlignY
      Case 0
        Disp.CurrentY = Y1 - Y0
      Case 1
        Disp.CurrentY = Y1 - Y0
      Case 2
        Disp.CurrentY = (Y1 + Y2 - H) / 2 - Y0
      Case 3
        Disp.CurrentY = Y2 - H - Y0
    End Select
    For I = 1 To UBound(WT)
      W = Disp.TextWidth(WT(I))
      Disp.CurrentX = X1 - X0
      Select Case obj.AlignX
        Case 0
          Disp.CurrentX = X1 - X0
        Case 1
          Disp.CurrentX = X1 - X0
        Case 2
          Disp.CurrentX = (X1 + X2 - W) / 2 - X0
        Case 3
          Disp.CurrentX = X2 - W - X0
      End Select
      Disp.Print WT(I)
    Next I
  ElseIf TypeOf obj Is PrnText Then
    GetRealPos Disp, X1, Y1, obj.X, obj.Y
    Set Disp.Font = New StdFont
    Disp.Font.Name = obj.Font.Name
    Disp.Font.Charset = obj.Font.Charset
    Disp.Font.Size = obj.Font.Size
    Disp.Font.Bold = obj.Font.Bold
    Disp.Font.Italic = obj.Font.Italic
    Disp.Font.Underline = obj.Font.Underline
    T = obj.Text
    W = Disp.TextWidth(T)
    H = Disp.TextHeight(T)
    Disp.CurrentX = X1 - X0
    Select Case obj.AlignX
      Case 1
        Disp.CurrentX = X1 - X0
      Case 2
        Disp.CurrentX = X1 - W / 2 - X0
      Case 3
        Disp.CurrentX = X1 - W - X0
    End Select
    Disp.CurrentY = Y1 - Y0
    Select Case obj.AlignY
      Case 1
        Disp.CurrentY = Y1 - Y0
      Case 2
        Disp.CurrentY = Y1 - H / 2 - Y0
      Case 3
        Disp.CurrentY = Y1 - H - Y0
    End Select
    Disp.Print obj.Text
  End If
  Set obj = Nothing
Next C
End Sub

Public Sub PreviewCurrentJob(Disp As PictureBox)

End Sub

Private Sub Class_Initialize()
Set colObjects = New Collection
ReDim vVarNames(0), vVarValues(0)
vOriginX = 0!: vOriginY = 0!
vRevertXAxis = False: vRevertYAxis = False
Set vFont = New StdFont
vForeColor = ColorConstants.vbBlack
vBackColor = ColorConstants.vbWhite
vLineWidth = 0.25!
vFormatText = True
End Sub

Private Sub Class_Terminate()
Set vFont = Nothing
While colObjects.Count > 0
  colObjects.Remove 1
Wend
Set colObjects = Nothing
Erase vVarNames(), vVarValues()
End Sub

Public Function CheckExist(ByVal ObjectName As String, ByVal ObjectType As ObjectTypes) As Boolean
Select Case ObjectType
  Case pjoPoint
    ObjectName = "Point " & ObjectName
  Case pjoLine
    ObjectName = "Line " & ObjectName
  Case pjoCircle
    ObjectName = "Circle " & ObjectName
  Case pjoBox
    ObjectName = "Box " & ObjectName
  Case pjoImage
    ObjectName = "Image " & ObjectName
  Case pjoTextBox
    ObjectName = "TextBox " & ObjectName
  Case pjoText
    ObjectName = "Text " & ObjectName
  Case Else
    Exit Function
End Select
On Error Resume Next
ObjectName = TypeName(colObjects(ObjectName))
CheckExist = (Err = 0)
Err.Clear
On Error GoTo 0
End Function

Private Function CheckObjectExist(ByVal ObjectName As String, ByVal ObjectType) As Boolean
Dim I As Long
If Len(ObjectName) = 0 Then Exit Function
If Not IsMissing(ObjectType) Then
  If IsObject(ObjectType) Then
    If Left$(TypeName(ObjectType), 3) = "Prn" Then ObjectName = Mid$(TypeName(ObjectType), 4) & vbSpace & ObjectName
  Else
    ObjectName = ObjectType & vbSpace & ObjectName
  End If
End If
On Error Resume Next
ObjectName = colObjects(ObjectName).Key
CheckObjectExist = (Err = 0)
On Error GoTo 0
End Function

Private Function VarIndex(ByVal VarName As String) As Long
Dim I As Long
For I = UBound(vVarNames) To 1 Step -1
  If vVarNames(I) = VarName Then Exit For
Next I
VarIndex = I
End Function

Public Sub VarAdd(ByVal VarName As String, Optional ByVal VarValue As String)
If VarIndex(VarName) > 0 Then Exit Sub
ReDim Preserve vVarNames(0 To UBound(vVarNames) + 1)
ReDim Preserve vVarValues(0 To UBound(vVarValues) + 1)
vVarNames(UBound(vVarNames)) = VarName
vVarValues(UBound(vVarValues)) = VarValue
End Sub

Public Sub VarSet(ByVal VarName As String, Optional ByVal VarValue As String)
Dim I As Long
I = VarIndex(VarName)
If I = 0 Then
  VarAdd VarName, VarValue
Else
  vVarValues(I) = VarValue
End If
End Sub

Public Sub VarDelete(ByVal Variable As Variant)
Dim I As Long
If VarType(Variable) = vbString Then Variable = VarIndex(Variable)
If Variable < 1 Or Variable > UBound(vVarNames) Then Exit Sub
For I = Variable To UBound(vVarNames) - 1
  vVarNames(I) = vVarNames(I + 1)
  vVarValues(I) = vVarValues(I + 1)
Next I
ReDim Preserve vVarNames(0 To UBound(vVarNames) - 1)
ReDim Preserve vVarValues(0 To UBound(vVarValues) - 1)
End Sub

Public Sub VarClear()
ReDim vVarNames(0), vVarNames(0)
End Sub

Public Function VarExist(ByVal Variable As Variant) As Boolean
Dim I As Long
If VarType(Variable) = vbString Then Variable = VarIndex(Variable)
VarExist = (Variable >= 1 And Variable <= UBound(vVarNames))
End Function

Public Function VarCount() As Long
VarCount = UBound(vVarNames)
End Function

Public Function VarName(ByVal VarIndex As Long) As String
If VarIndex < 1 Or VarIndex > UBound(vVarNames) Then Exit Function
VarName = vVarNames(VarIndex)
End Function

Public Property Get VarItem(ByVal Variable As Variant) As String
Dim I As Long
If VarType(Variable) = vbString Then Variable = VarIndex(Variable)
If Variable < 1 Or Variable > UBound(vVarNames) Then Exit Property
VarItem = vVarValues(Variable)
End Property

Public Property Let VarItem(ByVal Variable As Variant, ByVal NewValue As String)
Dim I As Long
If VarType(Variable) = vbString Then Variable = VarIndex(Variable)
If Variable < 1 Or Variable > UBound(vVarNames) Then Exit Property
vVarValues(Variable) = NewValue
End Property

Private Sub AddObject(Object As Object, Optional ByVal ObjectName As String)
If Len(ObjectName) = 0 Then
  colObjects.Add Item:=Object
Else
  ObjectName = Mid$(TypeName(Object), 4) & vbSpace & ObjectName
  On Error Resume Next
  colObjects.Add Key:=ObjectName, Item:=Object
  If Err > 0 Then Set Object = Nothing
  On Error GoTo 0
End If
End Sub

Public Property Get DefaultFont() As StdFont
Set DefaultFont = vFont
End Property

Public Property Set DefaultFont(ByVal NewValue As StdFont)
Set vFont = NewValue
End Property

Public Property Get DefaultForeColor() As OLE_COLOR
DefaultForeColor = vForeColor
End Property

Public Property Let DefaultForeColor(ByVal NewValue As OLE_COLOR)
vForeColor = NewValue
End Property

Public Property Get DefaultBackColor() As OLE_COLOR
DefaultBackColor = vBackColor
End Property

Public Property Let DefaultBackColor(ByVal NewValue As OLE_COLOR)
vBackColor = NewValue
End Property

Public Property Get DefaultLineWidth() As Single
DefaultLineWidth = vLineWidth
End Property

Public Property Let DefaultLineWidth(ByVal NewValue As Single)
If NewValue >= 0 Then vLineWidth = NewValue
End Property

Public Property Get DefaultFormatText() As Boolean
DefaultFormatText = vFormatText
End Property

Public Property Let DefaultFormatText(ByVal NewValue As Boolean)
vFormatText = NewValue
End Property

Public Property Get Tag() As String
Tag = vTag
End Property

Public Property Let Tag(ByVal NewValue As String)
vTag = NewValue
End Property

Public Function AddPoint(ByVal Name As String, ByVal X As Single, ByVal Y As Single, Optional ByVal Color) As PrnPoint
If IsMissing(Color) Then Color = vForeColor
Set AddPoint = New PrnPoint
AddPoint.SetPos X, Y
AddPoint.ForeColor = Color
AddPoint.Name = Name
AddObject AddPoint, Name
End Function

Public Function AddLine(ByVal Name As String, ByVal X1 As Single, Y1 As Single, X2 As Single, Y2 As Single, Optional ByVal LineWidth, Optional ByVal Color) As PrnLine
If IsMissing(LineWidth) Then LineWidth = vLineWidth
If IsMissing(Color) Then Color = vForeColor
Set AddLine = New PrnLine
AddLine.SetPointStart X1, Y1
AddLine.SetPointEnd X2, Y2
AddLine.LineWidth = LineWidth
AddLine.ForeColor = Color
AddLine.Name = Name
AddObject AddLine, Name
End Function

Public Function AddCircle(ByVal Name As String, ByVal X As Single, ByVal Y As Single, ByVal R As Single, Optional ByVal LineWidth, Optional ByVal Color) As PrnCircle
If IsMissing(LineWidth) Then LineWidth = vLineWidth
If IsMissing(Color) Then Color = vForeColor
Set AddCircle = New PrnCircle
AddCircle.SetPos X, Y
AddCircle.SetRadius R
AddCircle.LineWidth = LineWidth
AddCircle.ForeColor = Color
AddCircle.Name = Name
AddObject AddCircle, Name
End Function

Public Function AddBox(ByVal Name As String, ByVal X1 As Single, Y1 As Single, X2 As Single, Y2 As Single, Optional ByVal LineWidth, Optional ByVal Color, Optional ByVal FillColor) As PrnBox
If IsMissing(LineWidth) Then LineWidth = vLineWidth
If IsMissing(Color) Then Color = vForeColor
Set AddBox = New PrnBox
AddBox.SetPos X1, Y1, X2, Y2
AddBox.LineWidth = LineWidth
AddBox.ForeColor = Color
If IsMissing(FillColor) Then
  AddBox.Fill = False
Else
  AddBox.Fill = True
  AddBox.BackColor = FillColor
End If
AddBox.Name = Name
AddObject AddBox, Name
End Function

Public Function AddImage(ByVal Name As String, ByVal X1 As Single, Y1 As Single, X2 As Single, Y2 As Single, Optional ByVal Picture As StdPicture) As PrnImage
Set AddImage = New PrnImage
AddImage.SetPos X1, Y1, X2, Y2
Set AddImage.Image = Picture
AddImage.Name = Name
AddObject AddImage, Name
End Function

Public Function AddTextBox(ByVal Name As String, ByVal X1 As Single, Y1 As Single, X2 As Single, Y2 As Single, ByVal Text As String, Optional ByVal Color, Optional ByVal FormatText) As PrnTextBox
If IsMissing(FormatText) Then FormatText = vFormatText
If IsMissing(Color) Then Color = vForeColor
Set AddTextBox = New PrnTextBox
Set AddTextBox.Font = vFont
AddTextBox.SetPos X1, Y1, X2, Y2
AddTextBox.ForeColor = Color
AddTextBox.Text = Text
AddTextBox.FormatText = FormatText
AddTextBox.Name = Name
AddObject AddTextBox, Name
End Function

Public Function AddText(ByVal Name As String, ByVal X As Single, ByVal Y As Single, ByVal Text As String, Optional ByVal Color) As PrnText
If IsMissing(Color) Then Color = vForeColor
Set AddText = New PrnText
Set AddText.Font = vFont
AddText.SetPos X, Y
AddText.Fill = True
AddText.FillColor = Color
AddText.Text = Text
AddText.Name = Name
AddObject AddText, Name
End Function

Public Function Item(ByVal Index As Long) As Object
If Index < 1 Or Index > colObjects.Count Then Exit Function
Set Item = colObjects(Index)
End Function

Public Function ItemPoints(ByVal Index) As PrnPoint
Dim C As Long, I As Long
If VarType(Index) = vbString Then
  On Error Resume Next
  Set ItemPoints = colObjects("Point " & Index)
  On Error GoTo 0
Else
  Index = CLng(Index)
  If Index > 0 Then
    For I = 1 To colObjects.Count
      If TypeOf colObjects(I) Is PrnPoint Then C = C + 1
      If C = Index Then Exit For
    Next I
    If C > 0 And C <= colObjects.Count Then Set ItemPoints = colObjects(I)
  End If
End If
End Function

Public Function ItemLines(ByVal Index) As PrnLine
Dim C As Long, I As Long
If VarType(Index) = vbString Then
  On Error Resume Next
  Set ItemLines = colObjects("Line " & Index)
  On Error GoTo 0
Else
  Index = CLng(Index)
  If Index > 0 Then
    For I = 1 To colObjects.Count
      If TypeOf colObjects(I) Is PrnLine Then C = C + 1
      If C = Index Then Exit For
    Next I
    If C > 0 And C <= colObjects.Count Then Set ItemLines = colObjects(I)
  End If
End If
End Function

Public Function ItemCircles(ByVal Index) As PrnCircle
Dim C As Long, I As Long
If VarType(Index) = vbString Then
  On Error Resume Next
  Set ItemCircles = colObjects("Circle " & Index)
  On Error GoTo 0
Else
  Index = CLng(Index)
  If Index > 0 Then
    For I = 1 To colObjects.Count
      If TypeOf colObjects(I) Is PrnCircle Then C = C + 1
      If C = Index Then Exit For
    Next I
    If C > 0 And C <= colObjects.Count Then Set ItemCircles = colObjects(I)
  End If
End If
End Function

Public Function ItemBoxes(ByVal Index) As PrnBox
Dim C As Long, I As Long
If VarType(Index) = vbString Then
  On Error Resume Next
  Set ItemBoxes = colObjects("Box " & Index)
  On Error GoTo 0
Else
  Index = CLng(Index)
  If Index > 0 Then
    For I = 1 To colObjects.Count
      If TypeOf colObjects(I) Is PrnBox Then C = C + 1
      If C = Index Then Exit For
    Next I
    If C > 0 And C <= colObjects.Count Then Set ItemBoxes = colObjects(I)
  End If
End If
End Function

Public Function ItemImages(ByVal Index) As PrnImage
Dim C As Long, I As Long
If VarType(Index) = vbString Then
  On Error Resume Next
  Set ItemImages = colObjects("Image " & Index)
  On Error GoTo 0
Else
  Index = CLng(Index)
  If Index > 0 Then
    For I = 1 To colObjects.Count
      If TypeOf colObjects(I) Is PrnImage Then C = C + 1
      If C = Index Then Exit For
    Next I
    If C > 0 And C <= colObjects.Count Then Set ItemImages = colObjects(I)
  End If
End If
End Function

Public Function ItemTextBoxes(ByVal Index) As PrnTextBox
Dim C As Long, I As Long
If VarType(Index) = vbString Then
  On Error Resume Next
  Set ItemTextBoxes = colObjects("TextBox " & Index)
  On Error GoTo 0
Else
  Index = CLng(Index)
  If Index > 0 Then
    For I = 1 To colObjects.Count
      If TypeOf colObjects(I) Is PrnTextBox Then C = C + 1
      If C = Index Then Exit For
    Next I
    If C > 0 And C <= colObjects.Count Then Set ItemTextBoxes = colObjects(I)
  End If
End If
End Function

Public Function ItemTexts(ByVal Index) As PrnText
Dim C As Long, I As Long
If VarType(Index) = vbString Then
  On Error Resume Next
  Set ItemTexts = colObjects("Text " & Index)
  On Error GoTo 0
Else
  Index = CLng(Index)
  If Index > 0 Then
    For I = 1 To colObjects.Count
      If TypeOf colObjects(I) Is PrnText Then C = C + 1
      If C = Index Then Exit For
    Next I
    If C > 0 And C <= colObjects.Count Then Set ItemTexts = colObjects(I)
  End If
End If
End Function

Public Sub Remove(ByVal Index As Long)
If Index < 1 Or Index > colObjects.Count Then Exit Sub
colObjects.Remove Index
End Sub

Public Sub RemovePoints(ByVal Index As Long)
Dim C As Long, I As Long
If Index < 1 Then Exit Sub
For I = 1 To colObjects.Count
  If TypeOf colObjects(I) Is PrnPoint Then C = C + 1
  If C = Index Then Exit For
Next I
If C > 0 And C <= colObjects.Count Then colObjects.Remove C
End Sub

Public Sub RemoveLines(ByVal Index As Long)
Dim C As Long, I As Long
If Index < 1 Then Exit Sub
For I = 1 To colObjects.Count
  If TypeOf colObjects(I) Is PrnLine Then C = C + 1
  If C = Index Then Exit For
Next I
If C > 0 And C <= colObjects.Count Then colObjects.Remove C
End Sub

Public Sub RemoveCircles(ByVal Index As Long)
Dim C As Long, I As Long
If Index < 1 Then Exit Sub
For I = 1 To colObjects.Count
  If TypeOf colObjects(I) Is PrnCircle Then C = C + 1
  If C = Index Then Exit For
Next I
If C > 0 And C <= colObjects.Count Then colObjects.Remove C
End Sub

Public Sub RemoveBoxes(ByVal Index As Long)
Dim C As Long, I As Long
If Index < 1 Then Exit Sub
For I = 1 To colObjects.Count
  If TypeOf colObjects(I) Is PrnBox Then C = C + 1
  If C = Index Then Exit For
Next I
If C > 0 And C <= colObjects.Count Then colObjects.Remove C
End Sub

Public Sub RemoveImages(ByVal Index As Long)
Dim C As Long, I As Long
If Index < 1 Then Exit Sub
For I = 1 To colObjects.Count
  If TypeOf colObjects(I) Is PrnImage Then C = C + 1
  If C = Index Then Exit For
Next I
If C > 0 And C <= colObjects.Count Then colObjects.Remove C
End Sub

Public Sub RemoveTextBoxes(ByVal Index As Long)
Dim C As Long, I As Long
If Index < 1 Then Exit Sub
For I = 1 To colObjects.Count
  If TypeOf colObjects(I) Is PrnTextBox Then C = C + 1
  If C = Index Then Exit For
Next I
If C > 0 And C <= colObjects.Count Then colObjects.Remove C
End Sub

Public Sub RemoveTexts(ByVal Index As Long)
Dim C As Long, I As Long
If Index < 1 Then Exit Sub
For I = 1 To colObjects.Count
  If TypeOf colObjects(I) Is PrnText Then C = C + 1
  If C = Index Then Exit For
Next I
If C > 0 And C <= colObjects.Count Then colObjects.Remove C
End Sub

Public Sub Clear()
While colObjects.Count > 0
  colObjects.Remove 1
Wend
End Sub

Public Sub ClearPoints()
Dim C As Long, I As Long
C = colObjects.Count
For I = C To 1 Step -1
  If TypeOf colObjects(I) Is PrnPoint Then colObjects.Remove I
Next I
End Sub

Public Sub ClearLines()
Dim C As Long, I As Long
C = colObjects.Count
For I = C To 1 Step -1
  If TypeOf colObjects(I) Is PrnLine Then colObjects.Remove I
Next I
End Sub

Public Sub ClearCircles()
Dim C As Long, I As Long
C = colObjects.Count
For I = C To 1 Step -1
  If TypeOf colObjects(I) Is PrnCircle Then colObjects.Remove I
Next I
End Sub

Public Sub ClearBoxes()
Dim C As Long, I As Long
C = colObjects.Count
For I = C To 1 Step -1
  If TypeOf colObjects(I) Is PrnBox Then colObjects.Remove I
Next I
End Sub

Public Sub ClearImages()
Dim C As Long, I As Long
C = colObjects.Count
For I = C To 1 Step -1
  If TypeOf colObjects(I) Is PrnImage Then colObjects.Remove I
Next I
End Sub

Public Sub ClearTextBoxes()
Dim C As Long, I As Long
C = colObjects.Count
For I = C To 1 Step -1
  If TypeOf colObjects(I) Is PrnTextBox Then colObjects.Remove I
Next I
End Sub

Public Sub ClearTexts()
Dim C As Long, I As Long
C = colObjects.Count
For I = C To 1 Step -1
  If TypeOf colObjects(I) Is PrnText Then colObjects.Remove I
Next I
End Sub

Public Function Count() As Long
Count = colObjects.Count
End Function

Public Function CountPoints() As Long
Dim C As Long, I As Long
For I = 1 To colObjects.Count
  If TypeOf colObjects(I) Is PrnPoint Then C = C + 1
Next I
CountPoints = C
End Function

Public Function CountLines() As Long
Dim C As Long, I As Long
For I = 1 To colObjects.Count
  If TypeOf colObjects(I) Is PrnLine Then C = C + 1
Next I
CountLines = C
End Function

Public Function CountCircles() As Long
Dim C As Long, I As Long
For I = 1 To colObjects.Count
  If TypeOf colObjects(I) Is PrnCircle Then C = C + 1
Next I
CountCircles = C
End Function

Public Function CountBoxes() As Long
Dim C As Long, I As Long
For I = 1 To colObjects.Count
  If TypeOf colObjects(I) Is PrnBox Then C = C + 1
Next I
CountBoxes = C
End Function

Public Function CountImages() As Long
Dim C As Long, I As Long
For I = 1 To colObjects.Count
  If TypeOf colObjects(I) Is PrnImage Then C = C + 1
Next I
CountImages = C
End Function

Public Function CountTextBoxes() As Long
Dim C As Long, I As Long
For I = 1 To colObjects.Count
  If TypeOf colObjects(I) Is PrnTextBox Then C = C + 1
Next I
CountTextBoxes = C
End Function

Public Function CountTexts() As Long
Dim C As Long, I As Long
For I = 1 To colObjects.Count
  If TypeOf colObjects(I) Is PrnText Then C = C + 1
Next I
CountTexts = C
End Function
